#Second scheme: Optimal

import Metashape

doc = Metashape.app.document

for chunk in doc.chunks:

#alignment
    chunk.matchPhotos(
        downscale = 4,
        keypoint_limit = 0,
        tiepoint_limit = 0,
        mask_tiepoints = False,
        reset_matches = True,
        generic_preselection = True,
        reference_preselection = True)
        chunk.alignCameras(reset_alignment = True)
        doc.save()
     
#cloud filter          
    f = Metashape.PointCloud.Filter()
    
    reprojection_error_threshold = 0.5
    reconstruction_uncertainty_threshold = 10
    image_count_threshold = 2
    projection_accuracy_threshold = 20
    
    f.init(chunk, criterion = Metashape.PointCloud.Filter.ReprojectionError)
    f.removePoints(reprojection_error_threshold)
    
    f.init(chunk, criterion = Metashape.PointCloud.Filter.ReconstructionUncertainty)
    f.removePoints(reconstruction_uncertainty_threshold)
    
    f.init(chunk, criterion = Metashape.PointCloud.Filter.ImageCount)
    f.removePoints(image_count_threshold)
    
    f.init(chunk, criterion = Metashape.PointCloud.Filter.ProjectionAccuracy)
    f.removePoints(projection_accuracy_threshold)
    doc.save()
  
#optimization of point cloud  
    chunk.optimizeCameras(
        fit_f = True, 
        fit_cx = True, 
        fit_cy = True, 
        fit_b1 = True, 
        fit_b2 = True, 
        fit_k1 = True, 
        fit_k2 = True, 
        fit_k3 = True, 
        fit_k4 = True, 
        fit_p1 = True, 
        fit_p2 = True, 
    tiepoint_covariance = True)
    doc.save()

#build dense cloud 
    chunk.buildDepthMaps(downscale = 2, filter_mode = Metashape.AggressiveFiltering, reuse_depth = True)
    chunk.buildDenseCloud(point_colors = True)
    doc.save()

#build DEM
    chunk.buildDem(source_data = Metashape.DenseCloudData)
    doc.save()
    
#build orthomosaic  
    chunk.buildOrthomosaic(surface_data = Metashape.ElevationData)
    doc.save()

#remove orthophotos
    ortho = chunk.orthomosaic
    ortho.removeOrthophotos()
    doc.save() 

Metashape.app.messageBox("Well done!")
#Metashape.app.quit()

